/*
 * DMCInit.h
 *
 *  Created on: Jul 31, 2015
 *      Author: DGath
 */

#ifndef DMCINIT_H_
#define DMCINIT_H_

#include "defsc589.h"
#include "cdefsc589.h"
#include "stdint.h"
#include "stdio.h"
#include "stdbool.h"

#define DMC0_START_ADDRESS 0x80000000
#define DMC1_START_ADDRESS 0xC0000000

#define BUFF_SIZE 10

enum DDR_MODE
{
	DDR3_MODE,
	DDR2_MODE,
	LPDDR_MODE,
};

typedef struct
{
	uint32_t dmc_no;
	uint32_t ddr_mode;
	uint32_t cclk_dclk_ratio;
	uint32_t padctl2_value;
	uint32_t dmc_cfg_value;
	uint32_t dmc_ctl_value;
	uint32_t dmc_tr0_value;
	uint32_t dmc_tr1_value;
	uint32_t dmc_tr2_value;
	uint32_t dmc_mr0_value;
	uint32_t dmc_mr1_value;
	uint32_t dmc_mr2_value;
	uint32_t dmc_data_calib_add_value;
	bool phy_init_required;
	bool anomaly_20000037_applicable;
} DMC_PARAM;


void DMCInit(DMC_PARAM DMC_Param_List);
void DMC_PHY_Init(DMC_PARAM DMC_Param_List);
void DMC_Controller_Init(DMC_PARAM DMC_Param_List);
int Test_DMC_Basic(unsigned int start_address);

#endif /* DMCINIT_H_ */
